cdac.medinfo.sdk.hl7282.baselibs.segments

## Class ECR

- java.lang.Object
- - cdac.medinfo.sdk.hl7282.baselibs.segments.Segment
  - - cdac.medinfo.sdk.hl7282.baselibs.segments.ECR

- All Implemented Interfaces:
    ISegment

      public class ECR
      extends Segment

  ECR - Equipment Command Response Segment

  The equipment command response segment contains the receiving component's response to the previously received command.

  Represents an HL7 ECR message segment. This segment has the following fields:

  ECR-1: Command Response (CWE)Required
  ECR-2: Date/Time Completed (DTM)Required
  ECR-3: Command Response Parameters (TX)Optional

  This class provides mechanism to validate message against HL7 v 2.8.2 standard. The class provides accessors & mutators for the elements mentioned above. The class has validate method which validates Message against HL7 v 2.8.2 standard.

  User can also create Segment through `SegmentFactory`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ECR()` Constructs the ECR segment.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addCommandResponseParameters(java.lang.String strObservationDescription)` Add the Command Response Parameters.
    `void` | `addCommandResponseParameters(TX objCommandResponseParameters)` Add the Command Response Parameters.
    `CWE` | `getCommandResponse()` Retrieves the Command Response.
    `ISingleCollection<TX>` | `getCommandResponseParameters()` Retrieves the Command Response Parameters.
    `DTM` | `getDateTimeCompleted()` Retrieves the Date Time Completed.
    `void` | `setCommandResponse(CWE objCommandResponse)` Set the Command Response.
    `void` | `setCommandResponse(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Command Response.
    `void` | `setCommandResponseParameters(ISingleCollection<TX> objCommandResponseParametersList)` Set the Command Response Parameters.
    `void` | `setDateTimeCompleted(DTM objDateTimeCompleted)`
    `void` | `setDateTimeCompleted(java.lang.String strTime)` Set the Date Time Completed.
    `boolean` | `validate()` Validates HL7 Message objects .

    - ### Methods inherited from class cdac.medinfo.sdk.hl7282.baselibs.segments.Segment

      `addUnRecognizedField, dumpSegment, getFields, getName, getUnrecognizedFields, moveToNextSegment, parse, removeDataElement, removeDataElement, serialize, setName, setUnRecognizedField, updateDataElement, updateDataElement, writeToXML`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ECR

          public ECR()

      Constructs the ECR segment.

  - ### Method Detail

    - #### getCommandResponse

          public CWE getCommandResponse()

      Retrieves the Command Response. This field identify the response of the previously issued command.
      Returns:
        CWE - commandResponse

    - #### getCommandResponseParameters

          public ISingleCollection<TX> getCommandResponseParameters()

      Retrieves the Command Response Parameters. This field identify any associated parameters that relate to the returned response command message.
      Returns:
        ISingleCollection - commandResponseParameters

    - #### getDateTimeCompleted

          public DTM getDateTimeCompleted()

      Retrieves the Date Time Completed. This field contains the date and time that the receiving component completed the requested command.
      Returns:
        DTM - dateTimeCompleted

    - #### setCommandResponse

          public void setCommandResponse(java.lang.String strIdentifier,
                                java.lang.String strText,
                                java.lang.String strNameOfCodingSystem,
                                java.lang.String strAlternateIdentifier,
                                java.lang.String strAlternateText,
                                java.lang.String strNameOfAlternateCodingSystem,
                                java.lang.String strCodingSystemVersionID,
                                java.lang.String strAlternateCodingSystemVersionId,
                                java.lang.String strOriginalText,
                                java.lang.String strSecondAlternateIdentifier,
                                java.lang.String strSecondAlternateText,
                                java.lang.String strNameofSecondAlternateCodingSystem,
                                java.lang.String strSecondAlternateCodingSystemVersionID,
                                java.lang.String strCodingSystemOID,
                                java.lang.String strValueSetOID,
                                java.lang.String strValueSetVersionID,
                                java.lang.String strAlternateCodingSystemOID,
                                java.lang.String strAlternateValueSetOID,
                                java.lang.String strAlternateValueSetVersionID,
                                java.lang.String strSecondAlternateCodingSystemOID,
                                java.lang.String strSecondAlternateValueSetOID,
                                java.lang.String strSecondAlternateValueSetVersionID)

      Set the Command Response. This field identify the response of the previously issued command.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setCommandResponse

          public void setCommandResponse(CWE objCommandResponse)

      Set the Command Response. This field identify the response of the previously issued command.
      Parameters:
        `objCommandResponse` - Object of Command Response.

    - #### addCommandResponseParameters

          public void addCommandResponseParameters(java.lang.String strObservationDescription)

      Add the Command Response Parameters. This field identify any associated parameters that relate to the returned response command message.
      Parameters:
        `strObservationDescription` - String to be passed identifies the parameters of the command.

    - #### addCommandResponseParameters

          public void addCommandResponseParameters(TX objCommandResponseParameters)

      Add the Command Response Parameters. This field identify any associated parameters that relate to the returned response command message.
      Parameters:
        `objCommandResponseParameters` - Object of Command Response Parameters.

    - #### setCommandResponseParameters

          public void setCommandResponseParameters(ISingleCollection<TX> objCommandResponseParametersList)

      Set the Command Response Parameters. This field identify any associated parameters that relate to the returned response command message.
      Parameters:
        `objCommandResponseParametersList` - List of Command Response Parameters.

    - #### setDateTimeCompleted

          public void setDateTimeCompleted(java.lang.String strTime)

      Set the Date Time Completed. This field contains the date and time that the receiving component completed the requested command.
      Parameters:
        `strTime` - Specifies a point in time using a 24-hour clock notation.

    - #### setDateTimeCompleted

          public void setDateTimeCompleted(DTM objDateTimeCompleted)

    - #### validate

          public boolean validate()
                           throws InvalidSegmentException

      Validates HL7 Message objects . Validate method checks for validation each and every segments in side the Message object against specified message Structure. Validation checks include optionality of segment or group. It also verifies the number of times segment or group is repeated in message. e.g {PSH} while parsing PSH segment validate method will check for its mandatory presence. [PSH] in this case validate will throw exception if one tries to enter more than one PSH segment.
      Specified by:
        `validate` in interface `ISegment`
      Overrides:
        `validate` in class `Segment`
      Returns:
        boolean - true or false.
      Throws:
        `InvalidSegmentException` - Throws when Segment Validation fails.